#!/bin/sh
#-----------------------------------------------------------------------------
#
#  POPular -- A POP3 server and proxy for large mail systems
#
#  $Id: runtest.sh,v 1.6 2001/04/30 12:20:54 sqrt Exp $
#
#  http://www.remote.org/jochen/mail/popular/
#
#-----------------------------------------------------------------------------
#
#  Copyright (C) 1999-2001  Jochen Topf <jochen@remote.org>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
#
#-----------------------------------------------------------------------------


if (echo "testing\c"; echo 1,2,3) | grep c >/dev/null; then
  if (echo -n testing; echo 1,2,3) | sed s/-n/xn/ | grep xn >/dev/null; then
    echon() {
      echo "$*"
    }
  else
    echon() {
      echo -n "$*"
    }
  fi
else
  echon() {
      echo "$*\c"
  }
fi


perform_test() {
  echon "testing $1..."
  if $2 </dev/null 2>&1 | sed -e 's/^.*DBG 0000 //' >out/$2 2>&1; then
    if cmp -s match/$2 out/$2; then
      echo "passed"
      return 0
    else
      echo "failed"
      return 1
    fi
  else
    echo "failed"
    return 1
  fi
}


test_uds() {
  echo "This should come through the passed fd" >tmp/text
  ./t_uds_server tmp/uds-server.sock &
  sleep 1
  ./t_uds_client tmp/uds-client.sock tmp/uds-server.sock 4 4<tmp/text
  sleep 1
  ./t_uds_server tmp/uds-server.sock &
  sleep 1
  ./t_uds_client tmp/uds-client.sock tmp/uds-server.sock -1
}


test_search_string() {
  ./t_util_search_string
}


test_time_desc() {
  ./t_util_timedesc
}


#-----------------------------------------------------------------------------

rm -fr tmp out
mkdir -p tmp
mkdir -p out

echo
echo "=> Running tests. Look in out directory for output of tests."
echo

perform_test "bounded string search" test_search_string && SOME_FAILED=1
perform_test "date description" test_time_desc && SOME_FAILED=1
perform_test "UNIX domain socket stuff" test_uds && SOME_FAILED=1


#rm -fr tmp out

echo

if test $SOME_FAILED; then
  echo "=> Result: all tests successful"
  echo
  exit 0
else
  echo "=> Result: some tests failed"
  echo
  exit 1
fi


#-- THE END ------------------------------------------------------------------
