/*****************************************************************************

  POPular -- A POP3 server and proxy for large mail systems

  $Id: t_uds_client.c,v 1.2 2001/04/08 18:24:10 sqrt Exp $

  http://www.remote.org/jochen/mail/popular/

******************************************************************************

  Copyright (C) 1999-2001  Jochen Topf <jochen@remote.org>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA

*****************************************************************************/

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include "../src/popular.h"

int debug;


int
main(int argc, char *argv[])
{
  int s;

  if (argc != 4) {
    fprintf(stderr, "%s: need arguments: client-socket server-socket file-descriptor\n", argv[0]);
    exit(1);
  }

  debug = DG_ALL;

  s = uds_socket(argv[1], 0117);
  if (s < 0) {
    fprintf(stderr, "%s: uds_socket failed: %s\n", argv[0], strerror(errno));
    exit(1);
  }

  if (uds_send(s, argv[2], "huhu", atoi(argv[3])) != 0) {
    fprintf(stderr, "%s: uds_send failed: %s\n", argv[0], strerror(errno));
    exit(1);
  }

  if (unlink(argv[1]) != 0) {
    fprintf(stderr, "%s: unlink failed: %s\n", argv[0], strerror(errno));
    exit(1);
  }

  return 0;
}


/** THE END *****************************************************************/
