/*****************************************************************************

  POPular -- A POP3 server and proxy for large mail systems

  $Id: t_uds_server.c,v 1.3 2001/04/10 05:50:50 sqrt Exp $

  http://www.remote.org/jochen/mail/popular/

******************************************************************************

  Copyright (C) 1999-2001  Jochen Topf <jochen@remote.org>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA

*****************************************************************************/

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include "../src/popular.h"

int debug;


int
main(int argc, char *argv[])
{
  int s, fd, len;
  char name[109], buf[1024], buf2[1024];

  close(3);
  close(4);
  close(5);

  if (argc != 2) {
    fprintf(stderr, "%s: need socket name as command line argument\n", argv[0]);
    exit(1);
  }

  debug = DG_ALL;

  s = uds_socket(argv[1], 0117);
  if (s < 0) {
    fprintf(stderr, "%s: uds_socket failed: %s\n", argv[0], strerror(errno));
    exit(1);
  }

  alarm(3);

  switch (uds_recv(s, name, buf, sizeof(buf), &fd)) {
    case 1:
      fprintf(stderr, "%s: got fd %d\n", argv[0], fd);
      len = read(fd, buf2, sizeof(buf2)-1);
      if (len <= 0) {
        fprintf(stderr, "%s: read failed: %s\n", argv[0], strerror(errno));
        exit(1);
      }
      buf2[len] = '\0';
      fprintf(stderr, "%s: %s", argv[0], buf2);
      fprintf(stderr, "%s: got test '%s'\n", argv[0], buf);
      break;
    case 0:
      fprintf(stderr, "%s: got no fd\n", argv[0]);
      fprintf(stderr, "%s: got test '%s'\n", argv[0], buf);
      break;
    case -1:
      fprintf(stderr, "%s: uds_recv failed: %s\n", argv[0], strerror(errno));
      exit(1);
    default:
      fprintf(stderr, "%s: should never be here\n", argv[0]);
      exit(1);
  }

  if (unlink(argv[1]) != 0) {
    fprintf(stderr, "%s: unlink failed: %s\n", argv[0], strerror(errno));
    exit(1);
  }

  return 0;
}


/** THE END *****************************************************************/
