/*****************************************************************************

  POPular -- A POP3 server and proxy for large mail systems

  $Id: t_util_timedesc.c,v 1.2 2001/08/10 13:04:26 sqrt Exp $

  http://www.remote.org/jochen/mail/popular/

******************************************************************************

  Copyright (C) 1999-2001  Jochen Topf <jochen@remote.org>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA

*****************************************************************************/

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include "../src/popular.h"

void
test_timedesc2sec(char *desc)
{
  int s = timedesc2sec(desc, 0, 60*60*24*2);
	if (s < 0) {
		printf("%s ERROR\n", desc);
	} else {
		char *r = sec2timedesc(s);
		printf("%s = %d = %s\n", desc, s, r);
	}
}


int
main(int argc, char *argv[])
{
  test_timedesc2sec("");
  test_timedesc2sec("0");
  test_timedesc2sec("1");
  test_timedesc2sec("5s");
  test_timedesc2sec("10m");
  test_timedesc2sec("10m3");
  test_timedesc2sec("-1");
  test_timedesc2sec("-10s");
  test_timedesc2sec("3m-10s");
  test_timedesc2sec("2d10h13m4s");
  test_timedesc2sec("3d5m");
  test_timedesc2sec("5m10m3s");
  test_timedesc2sec("5m1h3s");
  test_timedesc2sec("100m");
  test_timedesc2sec("13x");
  test_timedesc2sec("xyz");
  test_timedesc2sec("a10m");
  return 0;
}


/** THE END *****************************************************************/
